# 3. 配置 Python

## 3.1. 建置需求

建置 CPython 所需的功能：

- A C11 compiler. Optional C11 features are not required.

- Support for IEEE 754 floating-point numbers and floating-point Not-a-Number (NaN).

- thread 的支援。

- OpenSSL 1.1.1 or newer for the `ssl` and `hashlib` modules.

- 在 Windows 上需要 Microsoft Visual Studio 2017 或更新版本。

在 3.5 版的變更: 在 Windows 上需要 Visual Studio 2015 或更新版本。

在 3.6 版的變更: Selected C99 features are now required, like `<stdint.h>` and `static inline` functions.

在 3.7 版的變更: 對執行緒與 OpenSSL 1.0.2 的支援現在是必要的。

在 3.10 版的變更: OpenSSL 1.1.1 現在是必要的。

在 3.11 版的變更: C11 compiler, IEEE 754 and NaN support are now required. On Windows, Visual Studio 2017 or later is required.

See also PEP 7 "Style Guide for C Code" and PEP 11 "CPython platform support".

## 3.2. 產生的檔案

To reduce build dependencies, Python source code contains multiple generated files. Commands to regenerate all generated files:

    make regen-all
    make regen-stdlib-module-names
    make regen-limited-abi
    make regen-configure

The `Makefile.pre.in` file documents generated files, their inputs, and tools used to regenerate them. Search for `regen-*` make targets.

### 3.2.1. 設定腳本

The `make regen-configure` command regenerates the `aclocal.m4` file and the `configure` script using the `Tools/build/regen-configure.sh` shell script which uses an Ubuntu container to get the same tools versions and have a reproducible output.

The container is optional, the following command can be run locally:

    autoreconf -ivf -Werror

The generated files can change depending on the exact `autoconf-archive`, `aclocal` and `pkg-config` versions.

## 3.3. 設定選項

List all `./configure` script options using:

    ./configure --help

請見 Python 原始碼發行版中的 `Misc/SpecialBuilds.txt`。

### 3.3.1. 一般選項

--enable-loadable-sqlite-extensions

  Support loadable extensions in the `_sqlite` extension module (default is no) of the `sqlite3` module.

  請見 `sqlite3` 模組的 `sqlite3.Connection.enable_load_extension()` 方法。

  在 3.6 版被加入.

--disable-ipv6

  停用 IPv6 支援（如果支援的話預設是啟用的），請見 `socket` 模組。

--enable-big-digits=[15|30]

  Define the size in bits of Python `int` digits: 15 or 30 bits.

  By default, the digit size is 30.

  將 `PYLONG_BITS_IN_DIGIT` 定義為 `15` 或 `30`。

  參閱 `sys.int_info.bits_per_digit`。

--with-suffix=SUFFIX

  將 Python 執行檔的後綴設定為 SUFFIX。

  在 Windows 和 macOS 上預設的後綴是 `.exe` （`python.exe` 執行檔）、在 Emscripten node 上為 `.js`、在 Emscripten 瀏覽器為 `.html`、在 WASI 上為 `.wasm`，以及在其他平台為空字串（`python` 執行檔）。

  在 3.11 版的變更: 在 WASM 平台上預設的後綴是 `.js`、`.html` 或 `.wasm` 中的一個。

--with-tzpath=<list of absolute paths separated by pathsep>

  Select the default time zone search path for `zoneinfo.TZPATH`. See the Compile-time configuration of the `zoneinfo` module.

  預設值：`/usr/share/zoneinfo:/usr/lib/zoneinfo:/usr/share/lib/zoneinfo:/etc/zoneinfo`。

  請見 `os.pathsep` 路徑分隔符號。

  在 3.9 版被加入.

--without-decimal-contextvar

  Build the `_decimal` extension module using a thread-local context rather than a coroutine-local context (default), see the `decimal` module.

  請見 `decimal.HAVE_CONTEXTVAR` 與 `contextvars` 模組。

  在 3.9 版被加入.

--with-dbmliborder=<list of backend names>

  Override order to check db backends for the `dbm` module

  A valid value is a colon (`:`) separated string with the backend names:

  - `ndbm`;

  - `gdbm`;

  - `bdb`.

--without-c-locale-coercion

  Disable C locale coercion to a UTF-8 based locale (enabled by default).

  不要定義 `PY_COERCE_C_LOCALE` 巨集。

  請見 `PYTHONCOERCECLOCALE` 與 PEP 538。

--without-freelists

  Disable all freelists except the empty tuple singleton.

  在 3.11 版被加入.

--with-platlibdir=DIRNAME

  Python 函式庫目錄名稱（預設為 `lib` ）。

  Fedora 和 SuSE 在 64 位元平台上使用 `lib64`。

  參閱 `sys.platlibdir`。

  在 3.9 版被加入.

--with-wheel-pkg-dir=PATH

  Directory of wheel packages used by the `ensurepip` module (none by default).

  Some Linux distribution packaging policies recommend against bundling dependencies. For example, Fedora installs wheel packages in the `/usr/share/python-wheels/` directory and don't install the `ensurepip._bundled` package.

  在 3.10 版被加入.

--with-pkg-config=[check|yes|no]

  Whether configure should use pkg-config to detect build dependencies.

  - `check` （預設）：pkg-config 是可選的

  - `yes`：pkg-config 是必要的

  - `no`：即使存在也不使用 pkg-config 來配置

  在 3.11 版被加入.

--enable-pystats

  Turn on internal statistics gathering.

  The statistics will be dumped to a arbitrary (probably unique) file in `/tmp/py_stats/`, or `C:\temp\py_stats\` on Windows. If that directory does not exist, results will be printed on stdout.

  使用 `Tools/scripts/summarize_stats.py` 來讀取統計資料。

  在 3.11 版被加入.

### 3.3.2. WebAssembly 選項

--with-emscripten-target=[browser|node]

  Set build flavor for `wasm32-emscripten`.

  - `browser` (default): preload minimal stdlib, default MEMFS.

  - `node`：對 NODERAWFS 和 pthread 支援。

  在 3.11 版被加入.

--enable-wasm-dynamic-linking

  Turn on dynamic linking support for WASM.

  Dynamic linking enables `dlopen`. File size of the executable increases due to limited dead code elimination and additional features.

  在 3.11 版被加入.

--enable-wasm-pthreads

  Turn on pthreads support for WASM.

  在 3.11 版被加入.

### 3.3.3. 安裝選項

--prefix=PREFIX

  Install architecture-independent files in PREFIX. On Unix, it defaults to `/usr/local`.

  這個值可以在 runtime 使用 `sys.prefix` 取得。

  As an example, one can use `--prefix="$HOME/.local/"` to install a Python in its home directory.

--exec-prefix=EPREFIX

  Install architecture-dependent files in EPREFIX, defaults to `--prefix`.

  這個值可以在 runtime 使用 `sys.exec_prefix` 取得

--disable-test-modules

  Don't build nor install test modules, like the `test` package or the `_testcapi` extension module (built and installed by default).

  在 3.10 版被加入.

--with-ensurepip=[upgrade|install|no]

  選擇在 Python 安裝時執行的 `ensurepip` 命令：

  - `upgrade` （預設）：執行 `python -m ensurepip --altinstall --upgrade` 命令。

  - `install`：執行 `python -m ensurepip --altinstall` 命令；

  - `no`：不要執行 ensurepip；

  在 3.6 版被加入.

### 3.3.4. Performance options

Configuring Python using `--enable-optimizations --with-lto` (PGO + LTO) is recommended for best performance. The experimental `--enable-bolt` flag can also be used to improve performance.

--enable-optimizations

  Enable Profile Guided Optimization (PGO) using `PROFILE_TASK` (disabled by default).

  The C compiler Clang requires `llvm-profdata` program for PGO. On macOS, GCC also requires it: GCC is just an alias to Clang on macOS.

  Disable also semantic interposition in libpython if `--enable-shared` and GCC is used: add `-fno-semantic-interposition` to the compiler and linker flags.

  備註

  During the build, you may encounter compiler warnings about profile data not being available for some source files. These warnings are harmless, as only a subset of the code is exercised during profile data acquisition. To disable these warnings on Clang, manually suppress them by adding `-Wno-profile-instr-unprofiled` to `CFLAGS`.

  在 3.6 版被加入.

  在 3.10 版的變更: 在 GCC 上使用 `-fno-semantic-interposition`。

PROFILE_TASK

  Environment variable used in the Makefile: Python command line arguments for the PGO generation task.

  預設值：`-m test --pgo --timeout=$(TESTTIMEOUT)`。

  在 3.8 版被加入.

--with-lto=[full|thin|no|yes]

  Enable Link Time Optimization (LTO) in any build (disabled by default).

  The C compiler Clang requires `llvm-ar` for LTO (`ar` on macOS), as well as an LTO-aware linker (`ld.gold` or `lld`).

  在 3.6 版被加入.

  在 3.11 版被加入: To use ThinLTO feature, use `--with-lto=thin` on Clang.

  在 3.12 版的變更: Use ThinLTO as the default optimization policy on Clang if the compiler accepts the flag.

--enable-bolt

  Enable usage of the BOLT post-link binary optimizer (disabled by default).

  BOLT is part of the LLVM project but is not always included in their binary distributions. This flag requires that `llvm-bolt` and `merge-fdata` are available.

  BOLT is still a fairly new project so this flag should be considered experimental for now. Because this tool operates on machine code its success is dependent on a combination of the build environment + the other optimization configure args + the CPU architecture, and not all combinations are supported. BOLT versions before LLVM 16 are known to crash BOLT under some scenarios. Use of LLVM 16 or newer for BOLT optimization is strongly encouraged.

  The `BOLT_INSTRUMENT_FLAGS` and `BOLT_APPLY_FLAGS` configure variables can be defined to override the default set of arguments for llvm-bolt to instrument and apply BOLT data to binaries, respectively.

  在 3.12 版被加入.

--with-computed-gotos

  Enable computed gotos in evaluation loop (enabled by default on supported compilers).

--without-pymalloc

  Disable the specialized Python memory allocator pymalloc (enabled by default).

  另請參閱 `PYTHONMALLOC` 環境變數。

--without-doc-strings

  Disable static documentation strings to reduce the memory footprint (enabled by default). Documentation strings defined in Python are not affected.

  不要定義 `WITH_DOC_STRINGS` 巨集。

  請見 `PyDoc_STRVAR()` 巨集。

--enable-profiling

  Enable C-level code profiling with `gprof` (disabled by default).

--with-strict-overflow

  Add `-fstrict-overflow` to the C compiler flags (by default we add `-fno-strict-overflow` instead).

### 3.3.5. Python Debug Build

A debug build is Python built with the `--with-pydebug` configure option.

Effects of a debug build:

- Display all warnings by default: the list of default warning filters is empty in the `warnings` module.

- 新增 `d` 到 `sys.abiflags`。

- 新增 `sys.gettotalrefcount()` 函式。

- 新增 `-X showrefcount` 命令列選項。

- Add `-d` command line option and `PYTHONDEBUG` environment variable to debug the parser.

- Add support for the `__lltrace__` variable: enable low-level tracing in the bytecode evaluation loop if the variable is defined.

- Install debug hooks on memory allocators to detect buffer overflow and other memory errors.

- 定義 `Py_DEBUG` 和 `Py_REF_DEBUG` 巨集。

- Add runtime checks: code surrounded by `#ifdef Py_DEBUG` and `#endif`. Enable `assert(...)` and `_PyObject_ASSERT(...)` assertions: don't set the `NDEBUG` macro (see also the `--with-assertions` configure option). Main runtime checks:

  - Add sanity checks on the function arguments.

  - Unicode and int objects are created with their memory filled with a pattern to detect usage of uninitialized objects.

  - Ensure that functions which can clear or replace the current exception are not called with an exception raised.

  - Check that deallocator functions don't change the current exception.

  - The garbage collector (`gc.collect()` function) runs some basic checks on objects consistency.

  - The `Py_SAFE_DOWNCAST()` macro checks for integer underflow and overflow when downcasting from wide types to narrow types.

See also the Python Development Mode and the `--with-trace-refs` configure option.

在 3.8 版的變更: Release builds and debug builds are now ABI compatible: defining the `Py_DEBUG` macro no longer implies the `Py_TRACE_REFS` macro (see the `--with-trace-refs` option), which introduces the only ABI incompatibility.

### 3.3.6. Debug options

--with-pydebug

  Build Python in debug mode: define the `Py_DEBUG` macro (disabled by default).

--with-trace-refs

  Enable tracing references for debugging purpose (disabled by default).

  效果：

  - 定義 `Py_TRACE_REFS` 巨集。

  - Add `sys.getobjects()` function.

  - 新增 `PYTHONDUMPREFS` 環境變數。

  This build is not ABI compatible with release build (default build) or debug build (`Py_DEBUG` and `Py_REF_DEBUG` macros).

  在 3.8 版被加入.

--with-assertions

  Build with C assertions enabled (default is no): `assert(...);` and `_PyObject_ASSERT(...);`.

  If set, the `NDEBUG` macro is not defined in the `OPT` compiler variable.

  See also the `--with-pydebug` option (debug build) which also enables assertions.

  在 3.6 版被加入.

--with-valgrind

  啟用 Valgrind 支援（預設不啟用）。

--with-dtrace

  啟用 DTrace 支援（預設不啟用）。

  See Instrumenting CPython with DTrace and SystemTap.

  在 3.6 版被加入.

--with-address-sanitizer

  Enable AddressSanitizer memory error detector, `asan` (default is no).

  在 3.6 版被加入.

--with-memory-sanitizer

  Enable MemorySanitizer allocation error detector, `msan` (default is no).

  在 3.6 版被加入.

--with-undefined-behavior-sanitizer

  Enable UndefinedBehaviorSanitizer undefined behaviour detector, `ubsan` (default is no).

  在 3.6 版被加入.

### 3.3.7. Linker options

--enable-shared

  Enable building a shared Python library: `libpython` (default is no).

--without-static-libpython

  Do not build `libpythonMAJOR.MINOR.a` and do not install `python.o` (built and enabled by default).

  在 3.10 版被加入.

### 3.3.8. 函式庫選項

--with-libs='lib1 ...'

  Link against additional libraries (default is no).

--with-system-expat

  Build the `pyexpat` module using an installed `expat` library (default is no).

--with-system-libmpdec

  Build the `_decimal` extension module using an installed `mpdec` library, see the `decimal` module (default is no).

  在 3.3 版被加入.

--with-readline=editline

  Use `editline` library for backend of the `readline` module.

  定義 `WITH_EDITLINE` 巨集。

  在 3.10 版被加入.

--without-readline

  Don't build the `readline` module (built by default).

  不要定義 `HAVE_LIBREADLINE` 巨集。

  在 3.10 版被加入.

--with-libm=STRING

  Override `libm` math library to STRING (default is system-dependent).

--with-libc=STRING

  Override `libc` C library to STRING (default is system-dependent).

--with-openssl=DIR

  Root of the OpenSSL directory.

  在 3.7 版被加入.

--with-openssl-rpath=[no|auto|DIR]

  Set runtime library directory (rpath) for OpenSSL libraries:

  - `no` (default): don't set rpath;

  - `auto`: auto-detect rpath from `--with-openssl` and `pkg-config`;

  - DIR: set an explicit rpath.

  在 3.10 版被加入.

### 3.3.9. Security Options

--with-hash-algorithm=[fnv|siphash13|siphash24]

  Select hash algorithm for use in `Python/pyhash.c`:

  - `siphash13` (default);

  - `siphash24`；

  - `fnv`。

  在 3.4 版被加入.

  在 3.11 版被加入: `siphash13` is added and it is the new default.

--with-builtin-hashlib-hashes=md5,sha1,sha256,sha512,sha3,blake2

  內建雜湊模組：

  - `md5`；

  - `sha1`；

  - `sha256`；

  - `sha512`；

  - `sha3` (with shake);

  - `blake2`。

  在 3.9 版被加入.

--with-ssl-default-suites=[python|openssl|STRING]

  Override the OpenSSL default cipher suites string:

  - `python` (default): use Python's preferred selection;

  - `openssl`: leave OpenSSL's defaults untouched;

  - STRING: use a custom string

  請見 `ssl` 模組。

  在 3.7 版被加入.

  在 3.10 版的變更: The settings `python` and STRING also set TLS 1.2 as minimum protocol version.

### 3.3.10. macOS 選項

參閱 `Mac/README.rst`。

--enable-universalsdk

--enable-universalsdk=SDKDIR

  Create a universal binary build. SDKDIR specifies which macOS SDK should be used to perform the build (default is no).

--enable-framework

--enable-framework=INSTALLDIR

  Create a Python.framework rather than a traditional Unix install. Optional INSTALLDIR specifies the installation path (default is no).

--with-universal-archs=ARCH

  Specify the kind of universal binary that should be created. This option is only valid when `--enable-universalsdk` is set.

  選項：

  - `universal2` (x86-64 and arm64);

  - `32-bit` (PPC and i386);

  - `64-bit` (PPC64 and x86-64);

  - `3-way` (i386, PPC and x86-64);

  - `intel` (i386 and x86-64);

  - `intel-32` (i386);

  - `intel-64` (x86-64);

  - `all` (PPC, i386, PPC64 and x86-64).

  Note that values for this configuration item are not the same as the identifiers used for universal binary wheels on macOS. See the Python Packaging User Guide for details on the packaging platform compatibility tags used on macOS

--with-framework-name=FRAMEWORK

  Specify the name for the python framework on macOS only valid when `--enable-framework` is set (default: `Python`).

### 3.3.11. Cross Compiling Options

Cross compiling, also known as cross building, can be used to build Python for another CPU architecture or platform. Cross compiling requires a Python interpreter for the build platform. The version of the build Python must match the version of the cross compiled host Python.

--build=BUILD

  configure for building on BUILD, usually guessed by config.guess.

--host=HOST

  cross-compile to build programs to run on HOST (target platform)

--with-build-python=path/to/python

  path to build `python` binary for cross compiling

  在 3.11 版被加入.

CONFIG_SITE=file

  An environment variable that points to a file with configure overrides.

  Example config.site file:

      # config.site-aarch64
      ac_cv_buggy_getaddrinfo=no
      ac_cv_file__dev_ptmx=yes
      ac_cv_file__dev_ptc=no

Cross compiling example:

    CONFIG_SITE=config.site-aarch64 ../configure \
        --build=x86_64-pc-linux-gnu \
        --host=aarch64-unknown-linux-gnu \
        --with-build-python=../x86_64/python

## 3.4. Python Build System

### 3.4.1. Main files of the build system

- `configure.ac` => `configure`；

- `Makefile.pre.in` => `Makefile` (created by `configure`);

- `pyconfig.h` (created by `configure`)；

- `Modules/Setup`: C extensions built by the Makefile using `Module/makesetup` shell script;

### 3.4.2. 主要建置步驟

- C files (`.c`) are built as object files (`.o`).

- A static `libpython` library (`.a`) is created from objects files.

- `python.o` and the static `libpython` library are linked into the final `python` program.

- C extensions are built by the Makefile (see `Modules/Setup`).

### 3.4.3. 主要 Makefile 目標

- `make`: Build Python with the standard library.

- `make platform:`: build the `python` program, but don't build the standard library extension modules.

- `make profile-opt`: build Python using Profile Guided Optimization (PGO). You can use the configure `--enable-optimizations` option to make this the default target of the `make` command (`make all` or just `make`).

- `make buildbottest`: Build Python and run the Python test suite, the same way than buildbots test Python. Set `TESTTIMEOUT` variable (in seconds) to change the test timeout (1200 by default: 20 minutes).

- `make install`: Build and install Python.

- `make regen-all`: Regenerate (almost) all generated files; `make regen-stdlib-module-names` and `autoconf` must be run separately for the remaining generated files.

- `make clean`: Remove built files.

- `make distclean`: Same than `make clean`, but remove also files created by the configure script.

### 3.4.4. C 擴充模組

Some C extensions are built as built-in modules, like the `sys` module. They are built with the `Py_BUILD_CORE_BUILTIN` macro defined. Built-in modules have no `__file__` attribute:

    >>> import sys
    >>> sys
    <module 'sys' (built-in)>
    >>> sys.__file__
    Traceback (most recent call last):
      File "<stdin>", line 1, in <module>
    AttributeError: module 'sys' has no attribute '__file__'

Other C extensions are built as dynamic libraries, like the `_asyncio` module. They are built with the `Py_BUILD_CORE_MODULE` macro defined. Example on Linux x86-64:

    >>> import _asyncio
    >>> _asyncio
    <module '_asyncio' from '/usr/lib64/python3.9/lib-dynload/_asyncio.cpython-39-x86_64-linux-gnu.so'>
    >>> _asyncio.__file__
    '/usr/lib64/python3.9/lib-dynload/_asyncio.cpython-39-x86_64-linux-gnu.so'

`Modules/Setup` is used to generate Makefile targets to build C extensions. At the beginning of the files, C extensions are built as built-in modules. Extensions defined after the `*shared*` marker are built as dynamic libraries.

The `PyAPI_FUNC()`, `PyAPI_DATA()` and `PyMODINIT_FUNC` macros of `Include/exports.h` are defined differently depending if the `Py_BUILD_CORE_MODULE` macro is defined:

- 如果定義了 `Py_BUILD_CORE_MODULE`，則使用 `Py_EXPORTED_SYMBOL`

- 否則使用 `Py_IMPORTED_SYMBOL`。

If the `Py_BUILD_CORE_BUILTIN` macro is used by mistake on a C extension built as a shared library, its `PyInit_xxx()` function is not exported, causing an `ImportError` on import.

## 3.5. Compiler and linker flags

Options set by the `./configure` script and environment variables and used by `Makefile`.

### 3.5.1. Preprocessor flags

CONFIGURE_CPPFLAGS

  Value of `CPPFLAGS` variable passed to the `./configure` script.

  在 3.6 版被加入.

CPPFLAGS

  (Objective) C/C++ preprocessor flags, e.g. `-Iinclude_dir` if you have headers in a nonstandard directory include_dir.

  Both `CPPFLAGS` and `LDFLAGS` need to contain the shell's value to be able to build extension modules using the directories specified in the environment variables.

BASECPPFLAGS

  在 3.4 版被加入.

PY_CPPFLAGS

  Extra preprocessor flags added for building the interpreter object files.

  Default: `$(BASECPPFLAGS) -I. -I$(srcdir)/Include $(CONFIGURE_CPPFLAGS) $(CPPFLAGS)`.

  在 3.2 版被加入.

### 3.5.2. 編譯器旗標

CC

  C 編譯器指令。

  Example: `gcc -pthread`.

CXX

  C++ 編譯器指令。

  範例：`g++ -pthread`。

CFLAGS

  C 編譯器旗標。

CFLAGS_NODIST

  `CFLAGS_NODIST` is used for building the interpreter and stdlib C extensions. Use it when a compiler flag should not be part of `CFLAGS` once Python is installed (gh-65320).

  In particular, `CFLAGS` should not contain:

  - the compiler flag `-I` (for setting the search path for include files). The `-I` flags are processed from left to right, and any flags in `CFLAGS` would take precedence over user- and package-supplied `-I` flags.

  - hardening flags such as `-Werror` because distributions cannot control whether packages installed by users conform to such heightened standards.

  在 3.5 版被加入.

COMPILEALL_OPTS

  Options passed to the `compileall` command line when building PYC files in `make install`. Default: `-j0`.

  在 3.12 版被加入.

EXTRA_CFLAGS

  額外的 C 編譯器旗標。

CONFIGURE_CFLAGS

  Value of `CFLAGS` variable passed to the `./configure` script.

  在 3.2 版被加入.

CONFIGURE_CFLAGS_NODIST

  Value of `CFLAGS_NODIST` variable passed to the `./configure` script.

  在 3.5 版被加入.

BASECFLAGS

  基本編譯器旗標。

OPT

  最佳化旗標。

CFLAGS_ALIASING

  Strict or non-strict aliasing flags used to compile `Python/dtoa.c`.

  在 3.7 版被加入.

CCSHARED

  Compiler flags used to build a shared library.

  例如說 `-fPIC` 被使用於 Linux 與 BSD 上。

CFLAGSFORSHARED

  Extra C flags added for building the interpreter object files.

  Default: `$(CCSHARED)` when `--enable-shared` is used, or an empty string otherwise.

PY_CFLAGS

  Default: `$(BASECFLAGS) $(OPT) $(CONFIGURE_CFLAGS) $(CFLAGS) $(EXTRA_CFLAGS)`.

PY_CFLAGS_NODIST

  Default: `$(CONFIGURE_CFLAGS_NODIST) $(CFLAGS_NODIST) -I$(srcdir)/Include/internal`.

  在 3.5 版被加入.

PY_STDMODULE_CFLAGS

  C flags used for building the interpreter object files.

  Default: `$(PY_CFLAGS) $(PY_CFLAGS_NODIST) $(PY_CPPFLAGS) $(CFLAGSFORSHARED)`.

  在 3.7 版被加入.

PY_CORE_CFLAGS

  Default: `$(PY_STDMODULE_CFLAGS) -DPy_BUILD_CORE`.

  在 3.2 版被加入.

PY_BUILTIN_MODULE_CFLAGS

  Compiler flags to build a standard library extension module as a built-in module, like the `posix` module.

  Default: `$(PY_STDMODULE_CFLAGS) -DPy_BUILD_CORE_BUILTIN`.

  在 3.8 版被加入.

PURIFY

  Purify command. Purify is a memory debugger program.

  Default: empty string (not used).

### 3.5.3. Linker flags

LINKCC

  Linker command used to build programs like `python` and `_testembed`.

  Default: `$(PURIFY) $(CC)`.

CONFIGURE_LDFLAGS

  Value of `LDFLAGS` variable passed to the `./configure` script.

  Avoid assigning `CFLAGS`, `LDFLAGS`, etc. so users can use them on the command line to append to these values without stomping the pre-set values.

  在 3.2 版被加入.

LDFLAGS_NODIST

  `LDFLAGS_NODIST` is used in the same manner as `CFLAGS_NODIST`. Use it when a linker flag should not be part of `LDFLAGS` once Python is installed (gh-65320).

  In particular, `LDFLAGS` should not contain:

  - the compiler flag `-L` (for setting the search path for libraries). The `-L` flags are processed from left to right, and any flags in `LDFLAGS` would take precedence over user- and package-supplied `-L` flags.

CONFIGURE_LDFLAGS_NODIST

  Value of `LDFLAGS_NODIST` variable passed to the `./configure` script.

  在 3.8 版被加入.

LDFLAGS

  Linker flags, e.g. `-Llib_dir` if you have libraries in a nonstandard directory lib_dir.

  Both `CPPFLAGS` and `LDFLAGS` need to contain the shell's value to be able to build extension modules using the directories specified in the environment variables.

LIBS

  Linker flags to pass libraries to the linker when linking the Python executable.

  範例：`-lrt`。

LDSHARED

  Command to build a shared library.

  預設值：`@LDSHARED@ $(PY_LDFLAGS)`。

BLDSHARED

  Command to build `libpython` shared library.

  預設值：`@BLDSHARED@ $(PY_CORE_LDFLAGS)`。

PY_LDFLAGS

  預設值：`$(CONFIGURE_LDFLAGS) $(LDFLAGS)`。

PY_LDFLAGS_NODIST

  預設值：`$(CONFIGURE_LDFLAGS_NODIST) $(LDFLAGS_NODIST)`。

  在 3.8 版被加入.

PY_CORE_LDFLAGS

  Linker flags used for building the interpreter object files.

  在 3.8 版被加入.